
#PIPER

Piper is a Perforce desktop client that is designed to be simpler to use than P4V. 

Note that Piper has nowhere near the functionality of P4V, and probably never will (in fact, the original project has a 2.0 version that has an even *simpler* interface!).

[HERE](https://swarm.workshop.perforce.com/projects/perforce-software-piper/view/main/mac/docs/Piper2NewFeatures/index.html) is a little video introduction describing the new features in Piper 2.0

### EXTRAS
The Piper project includes two [scripts](https://swarm.workshop.perforce.com/projects/perforce-software-piper/files/main/scripts):

* **SubmitTagger.py** - this script adds comma-delimited "tags" to the items in the corresponding changelist. By default, tags are specified in the changelist description using hashtag-style words (e.g. *#funStuff*). This script should be installed as a change-commit trigger:

`SUBMIT.tagger change-commit //... "/p4/common/bin/triggers/SubmitTagger.py -c %change%"`

* **ThumbnailGenerator.py** - this script uses ImageMagick to create png thumbnails of files and store them in the thumb attribute of file revisions in Perforce metadata. Piper will render these thumbnails, as will P4V. This script is intended to be configured as a cron job on the machine. It does not have to run on the same machine as the Perforce service, however. It keeps track of the last changelist that it indexed using a counter called `thumb-generator`. This script should be installed as a cron job.

## Requirements
### GENERAL

Piper has been tested with Perforce server version 2013.2-2014.2, although there is no reason that it should not work with an earlier Perforce version. Since Piper is compiled with the 2014.2 API, you would want to replace the libraries and recompile with the 2015.x API to use with a newer (2015+) server.

### P4Search
Piper can search the Perforce repository if you have [P4Search](https://swarm.workshop.perforce.com/projects/perforce-software-p4search) installed. Piper will look for a key called p4search.url and, if present, will allow you to perform searches within the application. For example:

`p4search.url = http://search.company.com:8088`

NOTE: this search utility uses the P4Search-specific API. You cannot just throw in your favorite search engine and expect things to work!

## Limitations

Currently, Piper only supports classic Perforce depots **(i.e. no streams)**. It wouldn't be too difficult to modify Piper to support using streams (and in fact might make workspace management a lot easier).

Piper has been compiled with the Perforce 2014.2 libraries, so you will probably have issues trying to connect to a 2015.x server. Replace the libraries and recompile if you are having problems.

## Support

Piper is distributed in a *BYOS* model... Bring Your Own Support.

### Issues

Issues are tracked on the Workshop under the [Jobs](https://swarm.workshop.perforce.com/projects/perforce-software-piper/jobs/)
tab.  

# PIPER/MAC

## Quick Start
Piper can be installed by mounting the DMG file ([Piper.dmg](https://swarm.workshop.perforce.com/files/guest/perforce_software/piper/mac/R2.0/dist/Piper.dmg)) and dragging the application within to your Applications directory.

When Piper launches, it registers the p4:// URL scheme to provide hyperlink capability directly into the application. 

## Requirements
Piper has been tested with Mac OSX 10.9 and above. 

## Building
The Mac version of Piper is compiled with XCode 6.3.1. To build the DMG, select the Product > Archive menu from within XCode. This will run a script that will produce the DMG in the dist directory.

# PIPER/WINDOWS

## Quick Start
The windows version of Piper includes an MSI installer ([msi](https://swarm.workshop.perforce.com/files/guest/perforce_software/piper/windows/R1.1/dist/Release/Piper_Installer.msi)).
The installer creates registry entries to associate the p4:// URL scheme with the Piper executable.

## Requirements
Piper has been tested with Windows 7 and Windows 8. Piper requires .Net 4.5 to function.

## Building
Piper has been developed using Visual Studio 2012. The dist.cmd scirpt in the root branch directory allows you to build the installer (running the devenv command).
`dist Release`



